/**********************************************************************
 *
 * $Id: stop_button_clicked.c,v 1.3 2000/05/03 23:31:50 htran Exp $
 *
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 **********************************************************************/


#include <errno.h>
#include <pthread.h>
#include <stdio.h>
#include <gtk/gtk.h>
#include "signal_callbacks.h"


void stop_button_clicked(GtkWidget *w,gpointer data){
  extern pthread_mutex_t playingLock;
  extern pthread_t videoThread, audioThread;
  
  int i=0;
  
  GtkWidget *action_area=data;
  GList *children;
  GList *cursor;
  
  children=gtk_container_children(GTK_CONTAINER(action_area));
  fprintf(stderr,"Stop button clicked\n");
  
  if( pthread_mutex_trylock(&playingLock)==EBUSY ){
	 pthread_cancel(videoThread);
	 pthread_join(videoThread,NULL);
	 pthread_cancel(audioThread);
	 pthread_join(audioThread,NULL);
  }
  else
	 pthread_mutex_unlock(&playingLock);
  
  
  for(cursor=children,i=0; cursor!=NULL ;cursor=cursor->next,i++){
    gtk_widget_set_state(GTK_WIDGET(cursor->data),GTK_STATE_ACTIVE);
    gtk_widget_set_sensitive(GTK_WIDGET(cursor->data),TRUE);
  }
  
}




